// Output generated from file: D:/fragmentarium/menger4_e-1_Files/menger4D rot.frag
// Created: Mon Jan 9 15:55:25 2017
// Output generated from file: D:/fragmentarium/menger45c-1_Files/menger4a.frag
// Created: Tue Dec 6 19:39:54 2016
// Output generated from file: D:/fragmentarium/out-18_Files/Menger4_c.frag
// Created: Sun Dec 4 11:00:57 2016
#info Mandelbox Distance Estimator.
#define providesInit
#include "DE-Raytracer.frag"
#include "MathUtils.frag"
#group Menger4
//Menger4, code from M3D, Darkbeam
//

/*
The distance estimator below was originally devised by Buddhi.
See this thread for more info: http://www.fractalforums.com/3d-fractal-generation/a-mandelbox-distance-estimate-formula/15/
*/
uniform int maxiter;  slider[0,10,50]
uniform int ColorIterations;  slider[0,3,300]
uniform float bailout; slider[0,16,100]
uniform float w; slider[-1.5,0,1.5]

// Menger Sponge
uniform int StartPreAdd;  slider[0,0,60]
uniform int StopPreAdd;  slider[0,0,60]
uniform vec4 PreAddM; slider[(-5.0,-5.0,-5.0,-5.0),(0.0,0.0,0.0,0.0),(5.0,5.0,5.0,5.0)]
uniform vec4 offsetM; slider[(-1.0,-1.0,-1.0,-1.0),(1.0,1.0,1.0,0.5),(5.0,5.0,5.0,5.0)]
uniform float scaleM;  slider[-5.0,3.0,5.0]
//vec4 offsetM = offsetT *(scaleM - 1.0);
float opt2 = 0.5 * offsetM.z  / scaleM;

uniform float anglXY; slider[-180.0,0.0,180.0]
uniform float anglYZ; slider[-180.0,0.0,180.0]
uniform float anglXZ; slider[-180.0,0.0,180.0]
uniform float anglXW; slider[-180.0,0.0,180.0]
uniform float anglYW; slider[-180.0,0.0,180.0]
uniform float anglZW; slider[-180.0,0.0,180.0]





// Iteration weight parameters
uniform bool iterW; checkbox[false]
uniform float scaleIW;  slider[0.8,1.0,1.0]
uniform float offsetA;  slider[-1.0,0.0,1.0]
uniform float offsetB;  slider[-1.0,0.0,1.0]
uniform int intA;  slider[0,0,25]
uniform int intB;  slider[0,0,25]



uniform vec3 RotVector; slider[(0,0,0),(1,1,1),(1,1,1)] 
uniform float RotAngle; slider[0.00,0,180]
mat3 rot;

void init() {
	 rot = rotationMatrix3(normalize(RotVector), RotAngle);
}
int i = 0;	
//float absScalem1 = abs(scaleM - 1.0);
//float AbsScaleRaisedTo1mIters = pow(abs(scaleM), float(1-i));

float DE(vec3 pos)
{
	vec4 z = vec4(pos,w);
	vec4 tp = z;
	float r2= 0.0;
	float Dd = 1.0;	
	float angleXY = anglXY * PI/180;
	float angleYZ = anglYZ * PI/180;
	float angleXZ = anglXZ * PI/180;
	float angleXW = anglXW * PI/180;
	float angleYW = anglYW * PI/180;
	float angleZW = anglZW * PI/180;


	
	for( i=0; i<maxiter ; i++)	
	
  {
		if (i >= StartPreAdd && i < StopPreAdd)
		{
			z += PreAddM; // offset
		}


		z = abs(z);// abs()
		vec4 temp4;
		//Conditional swizzle

		if ( z.y > z.x ) { temp4.x = z.y; z.y = z.x; z.x = temp4.x;}
		if ( z.z > z.x ) { temp4.x = z.z; z.z = z.x; z.x = temp4.x;}
		if ( z.z > z.y ) { temp4.y = z.z; z.z = z.y; z.y = temp4.y;}
		if ( z.w > z.x ) { temp4.x = z.w; z.w = z.x; z.x = temp4.x;}
		if ( z.w > z.y ) { temp4.x = z.w; z.w = z.y; z.y = temp4.x;}
		if ( z.w > z.z ) { temp4.y = z.w; z.w = z.z; z.z = temp4.y;}

	// temp 4D rotation



	if (angleXY != 0)
	{
		tp = z;
		z.x = tp.x * cos(angleXY) + tp.y * sin(angleXY);
		z.y = tp.x * -sin(angleXY) + tp.y * cos(angleXY);
	}
	if (angleYZ != 0)
	{
		tp = z;
		z.y = tp.y * cos(angleYZ) + tp.z * sin(angleYZ);
		z.z = tp.y * -sin(angleYZ) + tp.z * cos(angleYZ);
	}
	if (angleXZ != 0)
	{
		tp = z;
		z.x = tp.x * cos(angleXZ) + tp.z * sin(angleXZ);
		z.z = tp.x * -sin(angleXZ) + tp.z * cos(angleXZ);
	}
	if (angleXW != 0)
	{
		tp = z;
		z.x = tp.x * cos(angleXW) + tp.w * sin(angleXW);
		z.w = tp.x * -sin(angleXW) + tp.w * cos(angleXW);
	}
	if (angleYW != 0)
	{
		tp = z;
		z.y = tp.y * cos(angleYW) + tp.w * sin(angleYW);
		z.w = tp.y * -sin(angleYW) + tp.w * cos(angleYW);
	}
	if (angleZW != 0)
	{
		tp = z;
		z.z = tp.z * cos(angleZW) + tp.w * sin(angleZW);
		z.w = tp.z * -sin(angleZW) + tp.w * cos(angleZW);
	}



	// scale  and offset
		z.x = scaleM * z.x - offsetM.x;
		z.y = scaleM * z.y - offsetM.y;
		z.w = scaleM * z.w - offsetM.w;
		z.z -= opt2;
		z.z = -abs(-z.z);
		z.z += opt2;
		z.z *= scaleM;
		Dd *= scaleM;
	// iteration weight
		vec4 zA, zB;
		if (i == intA) zA = z;
		if (i == intB) zB = z;
		z = (z * scaleIW) + (zA * offsetA) + (zB * offsetB);
		Dd *= scaleIW; // * lengthZ0 / lengthZT;

		r2 = dot(z.xyz,z.xyz);// or //float r2=(z.x*z.x+z.y*z.y+z.z*z.z);
	//float r2=z.x*z.x+z.y*z.y+z.z*z.z+z.w*z.w;
		//r2 = length(z.xyz);
	
		if (i<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z.xyz,r2)));	

		if ( r2 > bailout)	
		{
			r2 = sqrt(r2);
			return r2 / Dd;
		//return (r - absScalem1) / Dd - AbsScaleRaisedTo1mIters;
		}
	}
}


























#preset Default
FOV = 0.4
Eye = 0,0,-2.5
Target = 0,0,3.5
Up = 0,1,0
EquiRectangular = false
AutoFocus = false
FocalPlane = 1
Aperture = 0
Gamma = 2
ToneMapping = 4
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Detail = -2.3
DetailAO = -0.5
FudgeFactor = 0.6979167
Dither = 0.5
NormalBackStep = 1
AO = 0,0,0,0.7
Specular = 0.4
SpecularExp = 16
SpecularMax = 10
SpotLight = 1,1,1,0.4
SpotLightDir = 0.1,0.1
CamLight = 1,1,1,1.59854
CamLightMin = 0
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
HardShadow = 0
ShadowSoft = 2
Reflection = 0
DebugSun = false
BaseColor = 1,0.7411765,0.6078431
OrbitStrength = 0.6175115
X = 0.5,0.6,0.6,0.433121
Y = 1,0.6,0,0.072
Z = 0.8,0.78,1,-0.352381
R = 0.4,0.7,1,0.0441767
BackgroundColor = 0.6,0.6,0.45
GradientBackground = 0.3
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,1
FloorHeight = 0
FloorColor = 1,1,1
MaxRaySteps = 56
maxiter = 10
ColorIterations = 3
bailout = 16
w = 0
StartPreAdd = 0
StopPreAdd = 2
PreAddM = 0,0,0,0
offsetM = 1,1,1,0.5
scaleM = 3
anglXY = -5.753425
anglYZ = 32.72727
anglXZ = -23.83562
anglXW = 1.682243
anglYW = -2.511628
anglZW = -10.88372
iterW = false
scaleIW = 1
offsetA = 0
offsetB = 0
intA = 0
intB = 0
RotVector = 1,1,1
RotAngle = 0
#endpreset

